# 1 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
!--------------------------------------------------------------------------------------------------!
!   CP2K: A general program to perform molecular dynamics simulations                              !
!   Copyright (C) 2000 - 2018  CP2K developers group                                               !
!--------------------------------------------------------------------------------------------------!

! **************************************************************************************************
!> \brief Wrapper for allocating, copying and reshaping arrays.
!> \author Patrick Seewald
! **************************************************************************************************
MODULE allocate_wrap

# 1 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/dbcsr_tensor.fypp" 1
# 5 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/dbcsr_tensor.fypp"
# 53 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/dbcsr_tensor.fypp"
# 13 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F" 2
# 14 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"

   USE kinds, ONLY: real_4, real_8

#include "../base/base_uses.f90"
   IMPLICIT NONE
   PRIVATE

   PUBLIC :: allocate_any

   INTERFACE allocate_any
# 25 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_1d_r_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_2d_r_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_3d_r_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_4d_r_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_5d_r_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_6d_r_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_7d_r_dp
# 28 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 25 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_1d_r_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_2d_r_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_3d_r_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_4d_r_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_5d_r_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_6d_r_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_7d_r_sp
# 28 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 25 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_1d_c_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_2d_c_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_3d_c_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_4d_c_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_5d_c_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_6d_c_dp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_7d_c_dp
# 28 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 25 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_1d_c_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_2d_c_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_3d_c_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_4d_c_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_5d_c_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_6d_c_sp
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_7d_c_sp
# 28 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 25 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_1d_i
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_2d_i
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_3d_i
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_4d_i
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_5d_i
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_6d_i
# 26 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
      MODULE PROCEDURE allocate_7d_i
# 28 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 29 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
   END INTERFACE

CONTAINS

# 34 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_1d_r_dp(array, shape_spec, source, order)
      REAL(kind=real_8), DIMENSION(:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_8), DIMENSION(:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(1)                                          :: order_prv
      INTEGER, DIMENSION(1)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 1)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1)))

      IF (PRESENT(source)) THEN
         array(:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_2d_r_dp(array, shape_spec, source, order)
      REAL(kind=real_8), DIMENSION(:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_8), DIMENSION(:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(2)                                          :: order_prv
      INTEGER, DIMENSION(2)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 2)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2)))

      IF (PRESENT(source)) THEN
         array(:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_3d_r_dp(array, shape_spec, source, order)
      REAL(kind=real_8), DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_8), DIMENSION(:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(3)                                          :: order_prv
      INTEGER, DIMENSION(3)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 3)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3)))

      IF (PRESENT(source)) THEN
         array(:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_4d_r_dp(array, shape_spec, source, order)
      REAL(kind=real_8), DIMENSION(:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_8), DIMENSION(:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(4)                                          :: order_prv
      INTEGER, DIMENSION(4)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 4)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_5d_r_dp(array, shape_spec, source, order)
      REAL(kind=real_8), DIMENSION(:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_8), DIMENSION(:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(5)                                          :: order_prv
      INTEGER, DIMENSION(5)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 5)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_6d_r_dp(array, shape_spec, source, order)
      REAL(kind=real_8), DIMENSION(:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_8), DIMENSION(:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(6)                                          :: order_prv
      INTEGER, DIMENSION(6)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 6)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_7d_r_dp(array, shape_spec, source, order)
      REAL(kind=real_8), DIMENSION(:,:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_8), DIMENSION(:,:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(7)                                          :: order_prv
      INTEGER, DIMENSION(7)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 7)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6), shape_prv(7)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 74 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 34 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_1d_r_sp(array, shape_spec, source, order)
      REAL(kind=real_4), DIMENSION(:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_4), DIMENSION(:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(1)                                          :: order_prv
      INTEGER, DIMENSION(1)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 1)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1)))

      IF (PRESENT(source)) THEN
         array(:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_2d_r_sp(array, shape_spec, source, order)
      REAL(kind=real_4), DIMENSION(:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_4), DIMENSION(:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(2)                                          :: order_prv
      INTEGER, DIMENSION(2)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 2)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2)))

      IF (PRESENT(source)) THEN
         array(:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_3d_r_sp(array, shape_spec, source, order)
      REAL(kind=real_4), DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_4), DIMENSION(:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(3)                                          :: order_prv
      INTEGER, DIMENSION(3)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 3)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3)))

      IF (PRESENT(source)) THEN
         array(:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_4d_r_sp(array, shape_spec, source, order)
      REAL(kind=real_4), DIMENSION(:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_4), DIMENSION(:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(4)                                          :: order_prv
      INTEGER, DIMENSION(4)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 4)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_5d_r_sp(array, shape_spec, source, order)
      REAL(kind=real_4), DIMENSION(:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_4), DIMENSION(:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(5)                                          :: order_prv
      INTEGER, DIMENSION(5)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 5)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_6d_r_sp(array, shape_spec, source, order)
      REAL(kind=real_4), DIMENSION(:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_4), DIMENSION(:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(6)                                          :: order_prv
      INTEGER, DIMENSION(6)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 6)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_7d_r_sp(array, shape_spec, source, order)
      REAL(kind=real_4), DIMENSION(:,:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: shape_spec
      REAL(kind=real_4), DIMENSION(:,:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(7)                                          :: order_prv
      INTEGER, DIMENSION(7)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 7)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6), shape_prv(7)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 74 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 34 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_1d_c_dp(array, shape_spec, source, order)
      COMPLEX(kind=real_8), DIMENSION(:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_8), DIMENSION(:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(1)                                          :: order_prv
      INTEGER, DIMENSION(1)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 1)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1)))

      IF (PRESENT(source)) THEN
         array(:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_2d_c_dp(array, shape_spec, source, order)
      COMPLEX(kind=real_8), DIMENSION(:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_8), DIMENSION(:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(2)                                          :: order_prv
      INTEGER, DIMENSION(2)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 2)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2)))

      IF (PRESENT(source)) THEN
         array(:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_3d_c_dp(array, shape_spec, source, order)
      COMPLEX(kind=real_8), DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_8), DIMENSION(:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(3)                                          :: order_prv
      INTEGER, DIMENSION(3)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 3)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3)))

      IF (PRESENT(source)) THEN
         array(:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_4d_c_dp(array, shape_spec, source, order)
      COMPLEX(kind=real_8), DIMENSION(:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_8), DIMENSION(:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(4)                                          :: order_prv
      INTEGER, DIMENSION(4)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 4)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_5d_c_dp(array, shape_spec, source, order)
      COMPLEX(kind=real_8), DIMENSION(:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_8), DIMENSION(:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(5)                                          :: order_prv
      INTEGER, DIMENSION(5)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 5)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_6d_c_dp(array, shape_spec, source, order)
      COMPLEX(kind=real_8), DIMENSION(:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_8), DIMENSION(:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(6)                                          :: order_prv
      INTEGER, DIMENSION(6)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 6)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_7d_c_dp(array, shape_spec, source, order)
      COMPLEX(kind=real_8), DIMENSION(:,:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_8), DIMENSION(:,:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(7)                                          :: order_prv
      INTEGER, DIMENSION(7)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 7)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6), shape_prv(7)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 74 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 34 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_1d_c_sp(array, shape_spec, source, order)
      COMPLEX(kind=real_4), DIMENSION(:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_4), DIMENSION(:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(1)                                          :: order_prv
      INTEGER, DIMENSION(1)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 1)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1)))

      IF (PRESENT(source)) THEN
         array(:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_2d_c_sp(array, shape_spec, source, order)
      COMPLEX(kind=real_4), DIMENSION(:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_4), DIMENSION(:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(2)                                          :: order_prv
      INTEGER, DIMENSION(2)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 2)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2)))

      IF (PRESENT(source)) THEN
         array(:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_3d_c_sp(array, shape_spec, source, order)
      COMPLEX(kind=real_4), DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_4), DIMENSION(:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(3)                                          :: order_prv
      INTEGER, DIMENSION(3)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 3)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3)))

      IF (PRESENT(source)) THEN
         array(:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_4d_c_sp(array, shape_spec, source, order)
      COMPLEX(kind=real_4), DIMENSION(:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_4), DIMENSION(:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(4)                                          :: order_prv
      INTEGER, DIMENSION(4)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 4)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_5d_c_sp(array, shape_spec, source, order)
      COMPLEX(kind=real_4), DIMENSION(:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_4), DIMENSION(:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(5)                                          :: order_prv
      INTEGER, DIMENSION(5)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 5)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_6d_c_sp(array, shape_spec, source, order)
      COMPLEX(kind=real_4), DIMENSION(:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_4), DIMENSION(:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(6)                                          :: order_prv
      INTEGER, DIMENSION(6)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 6)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_7d_c_sp(array, shape_spec, source, order)
      COMPLEX(kind=real_4), DIMENSION(:,:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: shape_spec
      COMPLEX(kind=real_4), DIMENSION(:,:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(7)                                          :: order_prv
      INTEGER, DIMENSION(7)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 7)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6), shape_prv(7)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 74 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 34 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_1d_i(array, shape_spec, source, order)
      INTEGER, DIMENSION(:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: shape_spec
      INTEGER, DIMENSION(:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(1), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(1)                                          :: order_prv
      INTEGER, DIMENSION(1)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 1)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1)))

      IF (PRESENT(source)) THEN
         array(:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_2d_i(array, shape_spec, source, order)
      INTEGER, DIMENSION(:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: shape_spec
      INTEGER, DIMENSION(:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(2), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(2)                                          :: order_prv
      INTEGER, DIMENSION(2)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 2)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2)))

      IF (PRESENT(source)) THEN
         array(:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_3d_i(array, shape_spec, source, order)
      INTEGER, DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: shape_spec
      INTEGER, DIMENSION(:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(3), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(3)                                          :: order_prv
      INTEGER, DIMENSION(3)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 3)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3)))

      IF (PRESENT(source)) THEN
         array(:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_4d_i(array, shape_spec, source, order)
      INTEGER, DIMENSION(:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: shape_spec
      INTEGER, DIMENSION(:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(4), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(4)                                          :: order_prv
      INTEGER, DIMENSION(4)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 4)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_5d_i(array, shape_spec, source, order)
      INTEGER, DIMENSION(:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: shape_spec
      INTEGER, DIMENSION(:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(5), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(5)                                          :: order_prv
      INTEGER, DIMENSION(5)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 5)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_6d_i(array, shape_spec, source, order)
      INTEGER, DIMENSION(:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: shape_spec
      INTEGER, DIMENSION(:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(6), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(6)                                          :: order_prv
      INTEGER, DIMENSION(6)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 6)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 35 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
! **************************************************************************************************
!> \brief Allocate array according to shape_spec. Possibly assign array from source.
!> \param shape shape of array to be allocated. If shape is not specified, it is derived from source.
!> \param array target array.
!> \param source source array to be copied to target array, must have same rank as target array.
!> \param order in which order to copy source to array (same convention as RESHAPE intrinsic).
!> \note  this does not fully replace Fortran RESHAPE intrinsic since source and target array must
!>        have same rank.
! *********************************************************************************
   SUBROUTINE allocate_7d_i(array, shape_spec, source, order)
      INTEGER, DIMENSION(:,:,:,:,:,:,:), ALLOCATABLE, INTENT(OUT) :: array
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: shape_spec
      INTEGER, DIMENSION(:,:,:,:,:,:,:), INTENT(IN), OPTIONAL     :: source
      INTEGER, DIMENSION(7), INTENT(IN), OPTIONAL                    :: order
      INTEGER, DIMENSION(7)                                          :: order_prv
      INTEGER, DIMENSION(7)                                          :: shape_prv
      INTEGER                                                              :: i

      CPASSERT(PRESENT(shape_spec) .OR. PRESENT(source))

      IF(PRESENT(order)) THEN
         order_prv(:) = order(:)
      ELSE
         order_prv(:) = (/(i, i=1, 7)/)
      ENDIF

      IF(PRESENT(source) .AND. .NOT. PRESENT(shape_spec)) THEN
         shape_prv(order_prv) = SHAPE(source)
      ELSE
         shape_prv(order_prv) = shape_spec
      ENDIF

      ALLOCATE(array(shape_prv(1), shape_prv(2), shape_prv(3), shape_prv(4), shape_prv(5), shape_prv(6), shape_prv(7)))

      IF (PRESENT(source)) THEN
         array(:,:,:,:,:,:,:) = RESHAPE(source, shape_prv, order=order_prv)
      ENDIF
   END SUBROUTINE
# 74 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
# 75 "/builddir/build/BUILD/cp2k-6.1/src/dbcsr_tensor/allocate_wrap.F"
END MODULE
